ORG     32500

Var:    LD		HL, 23627			; apuntador a la tabla de variables
        LD		E,(HL)				; obtener el octeto de menor peso
        INC		HL					; incrementar el apunrador
        LD		D,(HL)				; obtener el octeto de mayor peso
        LD		BC,$FFFF			; contador cargado con el máximo número posible
        EX		DE,HL				; llevar la dirección de la tabla de variables a HL
        LD		A,110				; octeto buscado (variable de Basic n)
        CPIR						; búsqueda del octeto
        RET     NZ                  ; si no encuentra la variable, retorno a BASIC (Línea nueva)    
        INC		HL					; saltar octeto
        INC		HL					; dos veces para que HL apunter al valor
        LD		C,(HL)				; llevar a C el octeto del menor peso
        INC		HL					; apuntar a octeto de mayor peso
        LD		B,(HL)				; octeto superior llevado a B
Line:   LD      HL,23635            ; apuntador al área de BASIC         
        LD      E,(HL)              ; obtener octeto inferior
        INC     HL                  ; incrementar apuntador
        LD      D,(HL)              ; obtener octeto superior
        EX      DE,HL               ; comienzo de BASIC
Comp:   LD      A,(HL)              ; octeto de mayor peso del nº de línea
        CP      B                   ; ¿iguales?
        INC     HL                  ; incrementar apuntador
        JR      NZ,Sig              ; distintos
        LD      A,(HL)              ; octeto de menor peso
        CP      C                   ; comparación
        JR      NZ,Sig              ; distintos
        DEC     HL                  ; línea encontrada
        LD      C,L                 ; cargar en C
        LD      B,H                 ; y B
        RET                         ; retorno a BASIC
Sig:    INC     HL                  ; octeto de menor peso del desplazamiento
        LD      E,(HL)              ; llevarlo a registro E
        INC     HL                  ; incrementar apuntador
        LD      D,(HL)              ; octeto de mayor peso a D
        ADD     HL,DE               ; fin de la línea
        INC     HL                  ; principio de línea
        ; Añadido para que si no encuentra la línea, termine
        LD      A, (HL)             ; A = octeto de mayor peso
        INC     HL                  ; incrementa apuntador
        OR      (HL)                ; evalúa si línea es 0
        DEC     HL                  ; decremennta apuntador
        RET     Z                   ; si es cero retorno a BASIC
        ; Sigue prograa original
        JR      Comp                ; repetir la búsqueda